@mixin basic-select {
    font-family: inherit;
    font-size: inherit;
    display: flex;
    flex-direction: column;

    .wrapper {
        display: inline-flex;
        align-items: stretch;
        border: 1px solid $color-input-border;
        border-radius: $border-radius;
        background-color: $color-input-background;
        position: relative;
        flex-grow: 1;

        &:hover:not(.wrapper--disabled):not(.wrapper--error),
        &:active:not(.wrapper--disabled):not(.wrapper--error),
        &:focus:not(.wrapper--disabled):not(.wrapper--error),
        &.focus:not(.wrapper--disabled):not(.wrapper--error) {
            border-color: $color-input-focus;
        }

        &.wrapper--disabled {
            color: $color-input-disabled;
            background-color: $color-input-background-disabled;

            & * {
                cursor: not-allowed;
            }
        }

        &.wrapper--readonly {
            color: $color-input-readonly;
            background-color: $color-input-background;
        }

        input {
            font-family: inherit;
            font-size: inherit;
            color: inherit;
            background-color: $color-input-background;
            box-shadow: none;
            outline: none;
            border: 0 none;
            border-radius: $border-radius;
            line-height: $line-height;
            box-sizing: content-box;

            &::placeholder {
                color: $color-input-placeholder;
            }

            &[disabled] {
                color: $color-input-disabled;
                background-color: $color-input-background-disabled;
            }
        }

        .options {
            list-style: none;
            padding: 0;
            margin: 0;
            display: none;
            flex-direction: column;
            position: absolute !important;
            background-color: $color-input-background;
            z-index: 10;
            box-shadow: 0 -1px 4px rgba(19, 41, 61, 0.04),
            0 4px 8px rgba(77, 65, 108, 0.12);
            border-radius: $border-radius;
            line-height: $line-height;
            width: auto;
            min-width: 100%;

            &.open {
                display: inline-flex;
            }

            &.up {
                bottom: calc(100% + 1px);
            }

            &.down {
                top: calc(100% + 1px);
            }

            .option {
                color: $color-input-focus;
                cursor: pointer;
                white-space: nowrap;
                text-align: left;

                &.active {
                    background-color: $grey-300;
                }

                &.disabled {
                    color: $color-input-disabled;
                }

                &:hover {
                    background-color: $grey-200;
                }
            }

            @for $height from 2 through 8 {
                &.height#{$height} {
                    max-height: calc(#{$height} * ((#{$line-height} * 1rem) + (#{$space} * #{$height})));
                }
            }
        }
    }

    &.error {
        .wrapper {
            border: 1px solid $color-input-border-error;
        }
    }

    &.label-position {
        &.top {
            display: flex;
            flex-wrap: nowrap;
            flex-direction: column;
        }

        &.left {
            display: flex;
            flex-wrap: nowrap;
            flex-direction: row;
            justify-content: space-between;
            align-items: center;
            @include marginBottom(6);
        }
    }

    .addon--wrapper {
        display: flex;
        flex-direction: row;
        align-items: center;
    }

    .error--wrapper {
        flex: 70%;
        display: flex;
        flex-direction: column;
        min-width: 0;

        .error {
            font-size: $font-size-small;
            color: $color-input-error;
            @include marginLeft(3);
        }
    }
}
